//============================================================================
// Name        : SimpleCppJsonWriter.cpp
// Author      : 
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <iomanip>
#include "SimpleCppJsonWriter.hpp"
#include "json.hpp"

using json = nlohmann::json;

SimpleCppJsonWriter::SimpleCppJsonWriter() {
}

SimpleCppJsonWriter::~SimpleCppJsonWriter() {
}

std::string SimpleCppJsonWriter::WriteJson() {
	// creating JSON Object
	json jsonData;

	// creating key value pair JSON Object
	jsonData["name"] = "File.mp3";
	jsonData["size"] = "25Mb";
	jsonData["section"] = "25Mb";

	//Creating a JSON Array
	int intarray[] = {1, 2, 3, 4};
	jsonData["list"] = intarray;

	// creating JSON Object
	json updateListJsonObj_one;
	updateListJsonObj_one["name"] = "user one";
	updateListJsonObj_one["date"] = "10:00 21 May";
	updateListJsonObj_one["userrole"] = { "add", "update", "delete"};

	// creating JSON Object
	json updateListJsonObj_two;
	updateListJsonObj_two["name"] = "user two";
	updateListJsonObj_two["date"] = "10:00 21 May";
	updateListJsonObj_two["userrole"] = { "add", "delete"};

	//Adding array to the JSON object as a value
	jsonData["updateby"] = { updateListJsonObj_one, updateListJsonObj_two };

	// creating JSON Object
	json metaDataJsonObj;
	metaDataJsonObj["create"] = "21 MAy";
	metaDataJsonObj["audio"] = "acc";
	metaDataJsonObj["video"] = "H264";

	//Adding JSON object to the JSON object as a value
	jsonData["Metadata"] = metaDataJsonObj;

	std::cout << "	Output JSON : "<< jsonData.dump() << std::endl;
	return jsonData.dump();
}
