//============================================================================
// Name        : SimpleCppJsonParser.cpp
// Author      : 
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include "SimpleCppJsonParser.hpp"
#include "json.hpp"

using json = nlohmann::json;

SimpleCppJsonParser::SimpleCppJsonParser() {

}

SimpleCppJsonParser::~SimpleCppJsonParser() {

}

void SimpleCppJsonParser::ParserJson(std::string _jsondata) {
	// parse string in JSON Object
	json jsonData = json::parse(_jsondata);

	for (auto it = jsonData.begin(); it != jsonData.end(); ++it) {

		//Gets all key from JSON object
		std::cout << "	*)  key: " << it.key() << " | value:" << it.value() << '\n';

	    // convenience type checkers
	    if(it.value().is_null()) {
	    	std::cout << "		Value is null" << std::endl;
	    } else if(it.value().is_boolean()) {
	    	std::cout << "		Value is boolean:" << it.value() << std::endl;
	    } else if(it.value().is_number()) {
	    	std::cout << "		Value is number :" << it.value() << std::endl;
	    } else if(it.value().is_object()) {
	    	std::cout << "		Value is object :" << it.value() << std::endl;

	    	//Parse Array
	    	for (auto& jsonObject : it.value().items())
	    	{
	    		std::cout << "			Object key : " << jsonObject.key() << " | value: " << jsonObject.value() << '\n';
	    	}
	    } else if(it.value().is_array()) {
	    	std::cout << "		Value is array  :" << it.value() << std::endl;

	    	//Parse Array
	    	for (auto& array : it.value().items())
	    	{
	    		std::cout << "			Array position : " << array.key() << " | value: " << array.value() << '\n';
	    	}

	    } else if(it.value().is_string()) {
	    	std::cout << "		Value is string :" << it.value() << std::endl;
	    } else {
	    	std::cout << "		Unknown data type!!" << std::endl;
	    }
	    std::cout << std::endl;
	}
	return ;
}
